<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Processors/Comments/Translator.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Processors/Comments/Translator.py</title>
<link href="../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Processors/Comments/Translator.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2006 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno"> 7</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line9"></a><span class="lineno"> 9</span><span class="line"><span class="py-keyword">from</span> Synopsis.DocString <span class="py-keyword">import</span> DocString</span>
<a id="line10"></a><span class="lineno">10</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Processor, Parameter</span>
<a id="line11"></a><span class="lineno">11</span><span class="line"><span class="py-keyword">from</span> Filter <span class="py-keyword">import</span> *</span>
<a id="line12"></a><span class="lineno">12</span>
<a id="line13"></a><span class="lineno">13</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Translator/Translator.html">Translator</a>(Processor, ASG.Visitor):</span>
<a id="line14"></a><span class="lineno">14</span><span class="line">    <span class="py-string">&quot;&quot;&quot;A Translator translates comments into documentation.&quot;&quot;&quot;</span></span>
<a id="line15"></a><span class="lineno">15</span>
<a id="line16"></a><span class="lineno">16</span><span class="line">    filter = Parameter(SSFilter(), <span class="py-string">'A comment filter to apply.'</span>)</span>
<a id="line17"></a><span class="lineno">17</span><span class="line">    processor = Parameter(None, <span class="py-string">'A comment processor to run.'</span>)</span>
<a id="line18"></a><span class="lineno">18</span><span class="line">    markup = Parameter(<span class="py-string">''</span>, <span class="py-string">'The markup type for this declaration.'</span>)</span>
<a id="line19"></a><span class="lineno">19</span><span class="line">    concatenate = Parameter(False, <span class="py-string">'Whether or not to concatenate adjacent comments.'</span>)</span>
<a id="line20"></a><span class="lineno">20</span><span class="line">    primary_only = Parameter(True, <span class="py-string">'Whether or not to preserve secondary comments.'</span>)</span>
<a id="line21"></a><span class="lineno">21</span>
<a id="line22"></a><span class="lineno">22</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Translator/Translator.html#process">process</a>(self, ir, **kwds):</span>
<a id="line23"></a><span class="lineno">23</span>
<a id="line24"></a><span class="lineno">24</span><span class="line">        self.set_parameters(kwds)</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">        self.ir = self.merge_input(ir)</span>
<a id="line26"></a><span class="lineno">26</span><span class="line">        <span class="py-keyword">if</span> self.filter:</span>
<a id="line27"></a><span class="lineno">27</span><span class="line">            self.ir = self.filter.process(self.ir)</span>
<a id="line28"></a><span class="lineno">28</span><span class="line">        <span class="py-keyword">if</span> self.processor:</span>
<a id="line29"></a><span class="lineno">29</span><span class="line">            self.ir = self.processor.process(self.ir)</span>
<a id="line30"></a><span class="lineno">30</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">        <span class="py-keyword">for</span> decl <span class="py-keyword">in</span> self.ir.asg.declarations:</span>
<a id="line32"></a><span class="lineno">32</span><span class="line">            decl.accept(self)</span>
<a id="line33"></a><span class="lineno">33</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">        <span class="py-keyword">return</span> self.output_and_return_ir()</span>
<a id="line35"></a><span class="lineno">35</span>
<a id="line36"></a><span class="lineno">36</span>
<a id="line37"></a><span class="lineno">37</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Translator/Translator.html#visit_declaration">visit_declaration</a>(self, decl):</span>
<a id="line38"></a><span class="lineno">38</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Map comments to a doc string.&quot;&quot;&quot;</span></span>
<a id="line39"></a><span class="lineno">39</span>
<a id="line40"></a><span class="lineno">40</span><span class="line">        comments = decl.annotations.get(<span class="py-string">'comments'</span>)</span>
<a id="line41"></a><span class="lineno">41</span><span class="line">        <span class="py-keyword">if</span> comments:</span>
<a id="line42"></a><span class="lineno">42</span><span class="line">            text = None</span>
<a id="line43"></a><span class="lineno">43</span><span class="line">            <span class="py-keyword">if</span> self.primary_only:</span>
<a id="line44"></a><span class="lineno">44</span><span class="line">                text = comments[-1]</span>
<a id="line45"></a><span class="lineno">45</span><span class="line">            <span class="py-keyword">elif</span> self.combine:</span>
<a id="line46"></a><span class="lineno">46</span><span class="line">                text = <span class="py-string">''</span>.join([c <span class="py-keyword">for</span> c <span class="py-keyword">in</span> comments <span class="py-keyword">if</span> c])</span>
<a id="line47"></a><span class="lineno">47</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line48"></a><span class="lineno">48</span><span class="line">                comments = comments[:]</span>
<a id="line49"></a><span class="lineno">49</span><span class="line">                comments.reverse()</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">                <span class="py-keyword">for</span> c <span class="py-keyword">in</span> comments:</span>
<a id="line51"></a><span class="lineno">51</span><span class="line">                    <span class="py-keyword">if</span> c <span class="py-keyword">is</span> <span class="py-keyword">not</span> None:</span>
<a id="line52"></a><span class="lineno">52</span><span class="line">                        text = c</span>
<a id="line53"></a><span class="lineno">53</span><span class="line">                        <span class="py-keyword">break</span></span>
<a id="line54"></a><span class="lineno">54</span><span class="line">            doc = DocString(text <span class="py-keyword">or</span> <span class="py-string">''</span>, self.markup)</span>
<a id="line55"></a><span class="lineno">55</span><span class="line">            decl.annotations[<span class="py-string">'doc'</span>] = doc</span>
<a id="line56"></a><span class="lineno">56</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:16 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
